var Sdk = window.Sdk || {};
(function () {
		
	//set Global vars
	//var context = Xrm.Page.context;
	var globalContext = Xrm.Utility.getGlobalContext();
	var serverURL =  globalContext.getClientUrl();  //Dynamics URL
	var organizationSettings = globalContext.organizationSettings //organizationSettings object for org information.
	var orgID = organizationSettings.organizationId; //unique Org Id
	var userSettings = globalContext.userSettings; // userSettings is an object with user information.
	var current_User_Id = userSettings.userId; // The user's unique id	
		
    // Code to run in the form OnLoad event
    this.formTabStateChange = function (executionContext) {		
				
		//set form variables
		var formContext = executionContext.getFormContext();
		var formType = formContext.ui.getFormType();  //gets the form mode, 1 = Create 2 = Update 5 = Quick Create
		var formEmail = formContext.getAttribute("emailaddress1").getValue();  //change attribute value if the Contact email field is not named emailaddress1
		
		//only exec if in Update form mode
		if (formType == 2){	
		
			//call Dynamics WebAPI to get logged in user's email
			var currentUserName = GetUserEmailAddress(serverURL, current_User_Id);
			var entityId = Xrm.Page.data.entity.getId().replace('{', '').replace('}', '');
						
			//set the current loggedin userid's email and the currently viewed Contact's email address to input parameters
			_UEmailParameter= currentUserName; //logged in user's email from the WebAPI
			_CEmailParameter = formEmail;  //contact's email from the form field
			
			//get the iFRAME and append src URL with custom parameters
			if(_UEmailParameter != "" && _CEmailParameter != "") {
				
				//create custom query string params for OrgID, userEmail and contactEmail
				var appendParams = "?orgId=" + orgID + "&userEmail=" + _UEmailParameter + "&contactEmail=" + _CEmailParameter;
				
				var IFrame = formContext.getControl("IFRAME_ClearlyRated"); //change form IFRAME name if different											 
				var Url = IFrame.getInitialUrl();  //get the original IFRAME src				
				var updUrl = Url +  appendParams; //appends the IFRAME src with custom params
				
				//for implementation, uncomment to update the iFRAME src and set to visible
				IFrame.setVisible(true);
				IFrame.setSrc(updUrl);			
				
			}
		}
		
	}
	
	function GetUserEmailAddress(serverUrl, UserId) {
		
		//since there is no current method to obtain logged in users' email, use the server-side Dynamics Organization Web Service
		
		//the ODataPath sets the Organization Service Url, it may be different depending on Dynamics version
		// Locate the Url in Settings -> -Customizations -> Developer Resources -> Organization Service
		var ODataPath = serverUrl + "/XRMServices/2011/OrganizationData.svc";
		var userRequest = new XMLHttpRequest();
		userRequest.open("GET", ODataPath + "/SystemUserSet(guid'"  + UserId +  "')", false);
		userRequest.setRequestHeader("Accept", "application/json"); 
		userRequest.setRequestHeader("Content-Type", "application/json; charset=utf-8"); 
		userRequest.send();
		if (userRequest.status === 200) {
			var retrievedUser = JSON.parse(userRequest.responseText).d; 
			var userEmail = retrievedUser.InternalEMailAddress;
			return userEmail;
		}
		else {
			return "error";
		}
	}
	
	    
	
}).call(Sdk);